diff --git a/app/code/core/Zend/Locale/Math/PhpMath.php b/app/code/core/Zend/Locale/Math/PhpMath.php
new file mode 100644
index 0000000..850940a
--- /dev/null
+++ b/app/code/core/Zend/Locale/Math/PhpMath.php
@@ -0,0 +1,254 @@
+<?php
+/**
+ * Zend Framework
+ *
+ * LICENSE
+ *
+ * This source file is subject to the new BSD license that is bundled
+ * with this package in the file LICENSE.txt.
+ * It is also available through the world-wide-web at this URL:
+ * http://framework.zend.com/license/new-bsd
+ * If you did not receive a copy of the license and are unable to
+ * obtain it through the world-wide-web, please send an email
+ * to license@zend.com so we can send you a copy immediately.
+ *
+ * @category   Zend
+ * @package    Zend_Locale
+ * @copyright  Copyright (c) 2005-2015 Zend Technologies USA Inc. (http://www.zend.com)
+ * @license    http://framework.zend.com/license/new-bsd     New BSD License
+ * @version    $Id$
+ */
+
+
+/**
+ * This class replaces default Zend_Locale_Math_PhpMath because of issues described in MPERF-10261 and MPERF-10262
+ * The only difference between current class and original one is overwritten implementation of Sub method
+ *
+ * Utility class for proxying math function to bcmath functions, if present,
+ * otherwise to PHP builtin math operators, with limited detection of overflow conditions.
+ * Sampling of PHP environments and platforms suggests that at least 80% to 90% support bcmath.
+ * This file should only be loaded for the 10% to 20% lacking access to the bcmath extension.
+ *
+ * @category   Zend
+ * @package    Zend_Locale
+ * @copyright  Copyright (c) 2005-2015 Zend Technologies USA Inc. (http://www.zend.com)
+ * @license    http://framework.zend.com/license/new-bsd     New BSD License
+ */
+class Zend_Locale_Math_PhpMath extends Zend_Locale_Math
+{
+    public static function disable()
+    {
+        self::$_bcmathDisabled = true;
+        self::$add   = array('Zend_Locale_Math_PhpMath', 'Add');
+        self::$sub   = array('Zend_Locale_Math_PhpMath', 'Sub');
+        self::$pow   = array('Zend_Locale_Math_PhpMath', 'Pow');
+        self::$mul   = array('Zend_Locale_Math_PhpMath', 'Mul');
+        self::$div   = array('Zend_Locale_Math_PhpMath', 'Div');
+        self::$comp  = array('Zend_Locale_Math_PhpMath', 'Comp');
+        self::$sqrt  = array('Zend_Locale_Math_PhpMath', 'Sqrt');
+        self::$mod   = array('Zend_Locale_Math_PhpMath', 'Mod');
+        self::$scale = array('Zend_Locale_Math_PhpMath', 'Scale');
+
+        self::$defaultScale     = 0;
+        self::$defaultPrecision = 1;
+    }
+
+    public static $defaultScale;
+    public static $defaultPrecision;
+
+
+    public static function Add($op1, $op2, $scale = null)
+    {
+        if ($scale === null) {
+            $scale     = Zend_Locale_Math_PhpMath::$defaultScale;
+            $precision = Zend_Locale_Math_PhpMath::$defaultPrecision;
+        } else {
+            $precision = pow(10, -$scale);
+        }
+
+        if (empty($op1)) {
+            $op1 = 0;
+        }
+        $op1 = self::normalize($op1);
+        $op2 = self::normalize($op2);
+        $result = $op1 + $op2;
+        if (is_infinite($result)  or  (abs($result - $op2 - $op1) > $precision)) {
+            #require_once 'Zend/Locale/Math/Exception.php';
+            throw new Zend_Locale_Math_Exception("addition overflow: $op1 + $op2 != $result", $op1, $op2, $result);
+        }
+
+        return self::round(self::normalize($result), $scale);
+    }
+
+    public static function Sub($op1, $op2, $scale = null)
+    {
+        if ($scale === null) {
+            $scale     = Zend_Locale_Math_PhpMath::$defaultScale;
+            $precision = Zend_Locale_Math_PhpMath::$defaultPrecision;
+        } else {
+            $precision = pow(10, -$scale);
+        }
+
+        if (empty($op1)) {
+            $op1 = 0;
+        }
+        if (empty($op2)) {
+            $op2 = 0;
+        }
+        $op1  = self::normalize($op1);
+        $op2  = self::normalize($op2);
+        $result = $op1 - $op2;
+        if (is_infinite($result)  or  (abs($result + $op2 - $op1) > $precision)) {
+            #require_once 'Zend/Locale/Math/Exception.php';
+            throw new Zend_Locale_Math_Exception("subtraction overflow: $op1 - $op2 != $result", $op1, $op2, $result);
+        }
+
+        return self::round(self::normalize($result), $scale);
+    }
+
+    public static function Pow($op1, $op2, $scale = null)
+    {
+        if ($scale === null) {
+            $scale = Zend_Locale_Math_PhpMath::$defaultScale;
+        }
+
+        $op1 = self::normalize($op1);
+        $op2 = self::normalize($op2);
+
+        // BCMath extension doesn't use decimal part of the power
+        // Provide the same behavior
+        $op2 = ($op2 > 0) ? floor($op2) : ceil($op2);
+
+        $result = pow($op1, $op2);
+        if (is_infinite($result)  or  is_nan($result)) {
+            #require_once 'Zend/Locale/Math/Exception.php';
+            throw new Zend_Locale_Math_Exception("power overflow: $op1 ^ $op2", $op1, $op2, $result);
+        }
+
+        return self::round(self::normalize($result), $scale);
+    }
+
+    public static function Mul($op1, $op2, $scale = null)
+    {
+        if ($scale === null) {
+            $scale = Zend_Locale_Math_PhpMath::$defaultScale;
+        }
+
+        if (empty($op1)) {
+            $op1 = 0;
+        }
+        $op1 = self::normalize($op1);
+        $op2 = self::normalize($op2);
+        $result = $op1 * $op2;
+        if (is_infinite($result)  or  is_nan($result)) {
+            #require_once 'Zend/Locale/Math/Exception.php';
+            throw new Zend_Locale_Math_Exception("multiplication overflow: $op1 * $op2 != $result", $op1, $op2, $result);
+        }
+
+        return self::round(self::normalize($result), $scale);
+    }
+
+    public static function Div($op1, $op2, $scale = null)
+    {
+        if ($scale === null) {
+            $scale = Zend_Locale_Math_PhpMath::$defaultScale;
+        }
+
+        if (empty($op2)) {
+            #require_once 'Zend/Locale/Math/Exception.php';
+            throw new Zend_Locale_Math_Exception("can not divide by zero", $op1, $op2, null);
+        }
+        if (empty($op1)) {
+            $op1 = 0;
+        }
+        $op1 = self::normalize($op1);
+        $op2 = self::normalize($op2);
+        $result = $op1 / $op2;
+        if (is_infinite($result)  or  is_nan($result)) {
+            #require_once 'Zend/Locale/Math/Exception.php';
+            throw new Zend_Locale_Math_Exception("division overflow: $op1 / $op2 != $result", $op1, $op2, $result);
+        }
+
+        return self::round(self::normalize($result), $scale);
+    }
+
+    public static function Sqrt($op1, $scale = null)
+    {
+        if ($scale === null) {
+            $scale = Zend_Locale_Math_PhpMath::$defaultScale;
+        }
+
+        if (empty($op1)) {
+            $op1 = 0;
+        }
+        $op1 = self::normalize($op1);
+        $result = sqrt($op1);
+        if (is_nan($result)) {
+            return NULL;
+        }
+
+        return self::round(self::normalize($result), $scale);
+    }
+
+    public static function Mod($op1, $op2)
+    {
+        if (empty($op1)) {
+            $op1 = 0;
+        }
+        if (empty($op2)) {
+            return NULL;
+        }
+        $op1 = self::normalize($op1);
+        $op2 = self::normalize($op2);
+        if ((int)$op2 == 0) {
+            return NULL;
+        }
+        $result = $op1 % $op2;
+        if (is_nan($result)  or  (($op1 - $result) % $op2 != 0)) {
+            #require_once 'Zend/Locale/Math/Exception.php';
+            throw new Zend_Locale_Math_Exception(
+                "modulus calculation error: $op1 % $op2 != $result", $op1, $op2, $result);
+        }
+
+        return self::normalize($result);
+    }
+
+    public static function Comp($op1, $op2, $scale = null)
+    {
+        if ($scale === null) {
+            $scale     = Zend_Locale_Math_PhpMath::$defaultScale;
+        }
+
+        if (empty($op1)) {
+            $op1 = 0;
+        }
+        $op1 = self::normalize($op1);
+        $op2 = self::normalize($op2);
+        if ($scale <> 0) {
+            $op1 = self::round($op1, $scale);
+            $op2 = self::round($op2, $scale);
+        } else {
+            $op1 = ($op1 > 0) ? floor($op1) : ceil($op1);
+            $op2 = ($op2 > 0) ? floor($op2) : ceil($op2);
+        }
+        if ($op1 > $op2) {
+            return 1;
+        } else if ($op1 < $op2) {
+            return -1;
+        }
+        return 0;
+    }
+
+    public static function Scale($scale)
+    {
+        if ($scale > 9) {
+            #require_once 'Zend/Locale/Math/Exception.php';
+            throw new Zend_Locale_Math_Exception("can not scale to precision $scale", $scale, null, null);
+        }
+        self::$defaultScale     = $scale;
+        self::$defaultPrecision = pow(10, -$scale);
+        return true;
+    }
+}
+
+Zend_Locale_Math_PhpMath::disable(); // disable use of bcmath functions
diff --git a/app/code/core/Zend/Validate/File/Upload.php b/app/code/core/Zend/Validate/File/Upload.php
new file mode 100644
index 0000000..ccca1c3
--- /dev/null
+++ b/app/code/core/Zend/Validate/File/Upload.php
@@ -0,0 +1,254 @@
+<?php
+/**
+ * Zend Framework
+ *
+ * LICENSE
+ *
+ * This source file is subject to the new BSD license that is bundled
+ * with this package in the file LICENSE.txt.
+ * It is also available through the world-wide-web at this URL:
+ * http://framework.zend.com/license/new-bsd
+ * If you did not receive a copy of the license and are unable to
+ * obtain it through the world-wide-web, please send an email
+ * to license@zend.com so we can send you a copy immediately.
+ *
+ * @category  Zend
+ * @package   Zend_Validate
+ * @copyright  Copyright (c) 2005-2015 Zend Technologies USA Inc. (http://www.zend.com)
+ * @license   http://framework.zend.com/license/new-bsd     New BSD License
+ * @version   $Id$
+ */
+
+/**
+ * @see Zend_Validate_Abstract
+ */
+#require_once 'Zend/Validate/Abstract.php';
+
+/**
+ * Validator for the maximum size of a file up to a max of 2GB
+ *
+ * @category  Zend
+ * @package   Zend_Validate
+ * @copyright  Copyright (c) 2005-2015 Zend Technologies USA Inc. (http://www.zend.com)
+ * @license   http://framework.zend.com/license/new-bsd     New BSD License
+ */
+class Zend_Validate_File_Upload extends Zend_Validate_Abstract
+{
+    /**@#+
+     * @const string Error constants
+     */
+    const INI_SIZE       = 'fileUploadErrorIniSize';
+    const FORM_SIZE      = 'fileUploadErrorFormSize';
+    const PARTIAL        = 'fileUploadErrorPartial';
+    const NO_FILE        = 'fileUploadErrorNoFile';
+    const NO_TMP_DIR     = 'fileUploadErrorNoTmpDir';
+    const CANT_WRITE     = 'fileUploadErrorCantWrite';
+    const EXTENSION      = 'fileUploadErrorExtension';
+    const ATTACK         = 'fileUploadErrorAttack';
+    const FILE_NOT_FOUND = 'fileUploadErrorFileNotFound';
+    const UNKNOWN        = 'fileUploadErrorUnknown';
+    /**@#-*/
+
+    /**
+     * @var array Error message templates
+     */
+    protected $_messageTemplates = array(
+        self::INI_SIZE       => "File '%value%' exceeds the defined ini size",
+        self::FORM_SIZE      => "File '%value%' exceeds the defined form size",
+        self::PARTIAL        => "File '%value%' was only partially uploaded",
+        self::NO_FILE        => "File '%value%' was not uploaded",
+        self::NO_TMP_DIR     => "No temporary directory was found for file '%value%'",
+        self::CANT_WRITE     => "File '%value%' can't be written",
+        self::EXTENSION      => "A PHP extension returned an error while uploading the file '%value%'",
+        self::ATTACK         => "File '%value%' was illegally uploaded. This could be a possible attack",
+        self::FILE_NOT_FOUND => "File '%value%' was not found",
+        self::UNKNOWN        => "Unknown error while uploading file '%value%'"
+    );
+
+    /**
+     * Internal array of files
+     * @var array
+     */
+    protected $_files = array();
+
+    /**
+     * Sets validator options
+     *
+     * The array $files must be given in syntax of Zend_File_Transfer to be checked
+     * If no files are given the $_FILES array will be used automatically.
+     * NOTE: This validator will only work with HTTP POST uploads!
+     *
+     * @param array|Zend_Config $files Array of files in syntax of Zend_File_Transfer
+     */
+    public function __construct($files = array())
+    {
+        if ($files instanceof Zend_Config) {
+            $files = $files->toArray();
+        }
+
+        $this->setFiles($files);
+    }
+
+    /**
+     * Returns the array of set files
+     *
+     * @param  string $file (Optional) The file to return in detail
+     * @return array
+     * @throws Zend_Validate_Exception If file is not found
+     */
+    public function getFiles($file = null)
+    {
+        if ($file !== null) {
+            $return = array();
+            foreach ($this->_files as $name => $content) {
+                if ($name === $file) {
+                    $return[$file] = $this->_files[$name];
+                }
+
+                if ($content['name'] === $file) {
+                    $return[$name] = $this->_files[$name];
+                }
+            }
+
+            if (count($return) === 0) {
+                #require_once 'Zend/Validate/Exception.php';
+                throw new Zend_Validate_Exception("The file '$file' was not found");
+            }
+
+            return $return;
+        }
+
+        return $this->_files;
+    }
+
+    /**
+     * Sets the files to be checked
+     *
+     * @param  array $files The files to check in syntax of Zend_File_Transfer
+     * @return Zend_Validate_File_Upload Provides a fluent interface
+     */
+    public function setFiles($files = array())
+    {
+        if (count($files) === 0) {
+            $this->_files = $_FILES;
+        } else {
+            $this->_files = $files;
+        }
+
+        // see ZF-10738
+        if (is_null($this->_files)) {
+            $this->_files = array();
+        }
+
+        foreach($this->_files as $file => $content) {
+            if (!isset($content['error'])) {
+                unset($this->_files[$file]);
+            }
+        }
+
+        return $this;
+    }
+
+    /**
+     * Defined by Zend_Validate_Interface
+     *
+     * Returns true if and only if the file was uploaded without errors
+     *
+     * @param  string $value Single file to check for upload errors, when giving null the $_FILES array
+     *                       from initialization will be used
+     * @param  string|null   $file
+     * @return boolean
+     */
+    public function isValid($value, $file = null)
+    {
+        $this->_messages = null;
+        if (array_key_exists($value, $this->_files)) {
+            $files[$value] = $this->_files[$value];
+        } else {
+            foreach ($this->_files as $file => $content) {
+                if (isset($content['name']) && ($content['name'] === $value)) {
+                    $files[$file] = $this->_files[$file];
+                }
+
+                if (isset($content['tmp_name']) && ($content['tmp_name'] === $value)) {
+                    $files[$file] = $this->_files[$file];
+                }
+            }
+        }
+
+        if (empty($files)) {
+            return $this->_throw($file, self::FILE_NOT_FOUND);
+        }
+
+        foreach ($files as $file => $content) {
+            $this->_value = $file;
+            switch($content['error']) {
+                case 0:
+                    if (!is_uploaded_file($content['tmp_name'])) {
+                        $this->_throw($content, self::ATTACK);
+                    }
+                    break;
+
+                case 1:
+                    $this->_throw($content, self::INI_SIZE);
+                    break;
+
+                case 2:
+                    $this->_throw($content, self::FORM_SIZE);
+                    break;
+
+                case 3:
+                    $this->_throw($content, self::PARTIAL);
+                    break;
+
+                case 4:
+                    $this->_throw($content, self::NO_FILE);
+                    break;
+
+                case 6:
+                    $this->_throw($content, self::NO_TMP_DIR);
+                    break;
+
+                case 7:
+                    $this->_throw($content, self::CANT_WRITE);
+                    break;
+
+                case 8:
+                    $this->_throw($content, self::EXTENSION);
+                    break;
+
+                default:
+                    $this->_throw($content, self::UNKNOWN);
+                    break;
+            }
+        }
+        /**
+         * PHP7.2 compatibility fix.
+         * More info https://wiki.php.net/rfc/counting_non_countables
+         */
+        if (isset($this->_messages) && count($this->_messages) > 0) {
+            return false;
+        } else {
+            return true;
+        }
+    }
+
+    /**
+     * Throws an error of the given type
+     *
+     * @param  string $file
+     * @param  string $errorType
+     * @return false
+     */
+    protected function _throw($file, $errorType)
+    {
+        if ($file !== null) {
+            if (is_array($file) and !empty($file['name'])) {
+                $this->_value = $file['name'];
+            }
+        }
+
+        $this->_error($errorType);
+        return false;
+    }
+}
diff --git a/dev/tests/functional/tests/app/Mage/Adminhtml/Test/Block/Sales/Order/Create/Payment.php b/dev/tests/functional/tests/app/Mage/Adminhtml/Test/Block/Sales/Order/Create/Payment.php
index 30eb174..f452881 100644
--- a/dev/tests/functional/tests/app/Mage/Adminhtml/Test/Block/Sales/Order/Create/Payment.php
+++ b/dev/tests/functional/tests/app/Mage/Adminhtml/Test/Block/Sales/Order/Create/Payment.php
@@ -58,8 +58,10 @@ class Payment extends Block
     public function selectPaymentMethod(array $paymentCode)
     {
         $paymentInput = $this->_rootElement->find(sprintf($this->paymentMethod, $paymentCode['method']));
-        if ($paymentInput->isVisible()) {
-            $paymentInput->click();
+        if ($paymentInput->isPresent()) {
+            if ($paymentInput->isVisible()) {
+                $paymentInput->click();
+            }
             $this->getTemplateBlock()->waitLoader();
         } else {
             throw new \Exception("{$paymentCode['method']} method is not visible.");
diff --git a/dev/tests/functional/tests/app/Mage/Paypal/Test/Block/NewLogin.php b/dev/tests/functional/tests/app/Mage/Paypal/Test/Block/NewLogin.php
index 02d8494..608bcfc 100644
--- a/dev/tests/functional/tests/app/Mage/Paypal/Test/Block/NewLogin.php
+++ b/dev/tests/functional/tests/app/Mage/Paypal/Test/Block/NewLogin.php
@@ -67,10 +67,12 @@ class NewLogin extends Login
         $this->clickToElement($this->startLoginButton);
         $this->_rootElement = $this->browser->find('.main');
         parent::fill($customer, $this->switchOnPayPalFrame($element));
-        $this->clickToElement($this->nextButton);
 
         $path = glob(MTF_TESTS_PATH . preg_replace('/^\w+\/\w+/', '*/*', str_replace('\\', '/', get_class($this))) . 'Password.xml');
         $this->mapping = $this->mapper->read(reset($path))['fields'];
+        if (!$this->browser->find($this->mapping['password']['selector'])->isVisible()) {
+            $this->clickToElement($this->nextButton);
+        }
         parent::fill($customer, $this->switchOnPayPalFrame($element));
 
         return $this;
diff --git a/downloader/Maged/Controller.php b/downloader/Maged/Controller.php
index 6387008..bcfb008 100644
--- a/downloader/Maged/Controller.php
+++ b/downloader/Maged/Controller.php
@@ -813,15 +813,17 @@ final class Maged_Controller
      */
     public function dispatch()
     {
-        $baseUrl = Mage::getBaseUrl(
-            Mage_Core_Model_Store::URL_TYPE_LINK, Mage::getSingleton('adminhtml/url')->getSecure()
-        );
-        if (strpos($baseUrl, 'https') === 0) {
-            $request = Mage::app()->getRequest();
-            if (!$request->isSecure()) {
-                Mage::app()->getFrontController()->getResponse()
-                    ->setRedirect(rtrim($baseUrl, '/') . $request->getRequestUri(), 301)->sendResponse();
-                exit;
+        if (class_exists('Mage')) {
+            $baseUrl = Mage::getBaseUrl(
+                Mage_Core_Model_Store::URL_TYPE_LINK, Mage::getSingleton('adminhtml/url')->getSecure()
+            );
+            if (strpos($baseUrl, 'https') === 0) {
+                $request = Mage::app()->getRequest();
+                if (!$request->isSecure()) {
+                    Mage::app()->getFrontController()->getResponse()
+                        ->setRedirect(rtrim($baseUrl, '/') . $request->getRequestUri(), 301)->sendResponse();
+                    exit;
+                }
             }
         }
 
@@ -1071,8 +1073,8 @@ final class Maged_Controller
         return array(
             'major'     => '1',
             'minor'     => '9',
-            'revision'  => '3',
-            'patch'     => '10',
+            'revision'  => '4',
+            'patch'     => '0',
             'stability' => '',
             'number'    => '',
         );
diff --git a/js/prototype/validation.js b/js/prototype/validation.js
index 8e671e2..5ea0b32 100644
--- a/js/prototype/validation.js
+++ b/js/prototype/validation.js
@@ -482,6 +482,9 @@ Validation.addAllThese([
     ['validate-code', 'Please use only letters (a-z), numbers (0-9) or underscore(_) in this field, first character should be a letter.', function (v) {
                 return Validation.get('IsEmpty').test(v) ||  /^[a-z]+[a-z0-9_]+$/.test(v)
             }],
+    ['validate-code-event', 'Please do not use "event" for an attribute code.', function (v) {
+        return Validation.get('IsEmpty').test(v) || !/^(event)$/.test(v)
+            }],
     ['validate-alphanum', 'Please use only letters (a-z or A-Z) or numbers (0-9) only in this field. No spaces or other characters are allowed.', function(v) {
                 return Validation.get('IsEmpty').test(v) || /^[a-zA-Z0-9]+$/.test(v)
             }],
diff --git a/lib/Varien/Autoload.php b/lib/Varien/Autoload.php
index b842be6..f91fec5 100644
--- a/lib/Varien/Autoload.php
+++ b/lib/Varien/Autoload.php
@@ -91,7 +91,7 @@ class Varien_Autoload
         }
         $classFile.= '.php';
         //echo $classFile;die();
-        return include $classFile;
+        return @include $classFile;
     }
 
     /**
diff --git a/lib/Varien/File/Uploader.php b/lib/Varien/File/Uploader.php
index 06a8bb1..6b797ba 100644
--- a/lib/Varien/File/Uploader.php
+++ b/lib/Varien/File/Uploader.php
@@ -519,7 +519,7 @@ class Varien_File_Uploader
 
                 $fileAttributes = $tmp_var;
                 $this->_file = $fileAttributes;
-            } elseif( count($fileId) > 0 && isset($_FILES[$fileId])) {
+            } elseif(!empty($fileId) && isset($_FILES[$fileId])) {
                 $this->_uploadType = self::SINGLE_STYLE;
                 $this->_file = $_FILES[$fileId];
             } elseif( $fileId == '' ) {
diff --git a/lib/Varien/Io/Sftp.php b/lib/Varien/Io/Sftp.php
index aa56fae..2e22c60 100644
--- a/lib/Varien/Io/Sftp.php
+++ b/lib/Varien/Io/Sftp.php
@@ -40,7 +40,7 @@ class Varien_Io_Sftp extends Varien_Io_Abstract implements Varien_Io_Interface
     const SSH2_PORT = 22;
 
     /**
-     * @var Net_SFTP $_connection
+     * @var phpseclib\Net\SFTP $_connection
      */
     protected $_connection = null;
 
@@ -66,7 +66,7 @@ class Varien_Io_Sftp extends Varien_Io_Abstract implements Varien_Io_Interface
             $host = $args['host'];
             $port = self::SSH2_PORT;
         }
-        $this->_connection = new Net_SFTP($host, $port, $args['timeout']);
+        $this->_connection = new phpseclib\Net\SFTP($host, $port, $args['timeout']);
         if (!$this->_connection->login($args['username'], $args['password'])) {
             throw new Exception(sprintf(__("Unable to open SFTP connection as %s@%s", $args['username'], $args['host'])));
         }
